unit Co;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DB, Grids, DBGrids, DBTables, FileCtrl,
  ExtCtrls;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DBGrid1: TDBGrid;
    DataSource1: TDataSource;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    OpenDialog1: TOpenDialog;
    OpenDialog2: TOpenDialog;
    Edit4: TEdit;
    Panel1: TPanel;
    Panel2: TPanel;
    FontDialog1: TFontDialog;
    Button5: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
    Trans1,
    Trans2   : String;

    Procedure ReadTransTables;
    Procedure Error(S:String);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}


procedure TForm1.Button1Click(Sender: TObject);
begin
   If OpenDialog1.Execute Then
      Begin
         Edit1.Text:=OpenDialog1.FileName;
         Table1.Close;
         Table1.TableName:=OpenDialog1.FileName;
         Table1.Open;
      End;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
   If OpenDialog2.Execute Then
      Begin
         Edit2.Text:=OpenDialog2.FileName;
      End;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
   If OpenDialog2.Execute Then
      Begin
         Edit3.Text:=OpenDialog2.FileName;
      End;
end;

procedure TForm1.Button4Click(Sender: TObject);
Var S,
    S1 : String;
    I,
    J  : Word;
begin
   If (Table1.Active    ) And
      (Edit2.Text <> '' ) And
      (Edit3.Text <> '' ) Then
      Begin
         ReadTransTables;
         Try
            With Table1 Do
               Begin
                  First;
                  While Not Table1.EOF Do
                     Begin
                        For I:=0 To FieldCount - 1 Do
                           If Fields[I].DataType = ftString Then
                              Begin
                                 S:='';
                                 S:=Fields[I].AsString;
                                 S1:='';

                                 If Length(S) > 0 Then
                                    For J:=1 To Length(S) Do
                                       Begin
                                          If Pos(S[J],Trans1) <> 0 Then
                                             S1:=S1 + Trans2[Pos(S[J],Trans1)]
                                          Else
                                             S1:=S1 + S[J];
                                       End;

                                 Edit;
                                 Fields[I].AsString:=S1;
                                 Post;
                              End;
                        Next;
                     End;

                  Close;
                  Open;
               End;
         Except
            Error('Data Base Error');
         End;
      End
   Else
      Error('Not Ready Yet');
end;

Procedure TForm1.ReadTransTables;
   Var F : TextFile;
   Begin
      Try
         AsSignFile(F,Edit2.Text);
         ReSet(F);
         ReadLn(F,Trans1);
         CloseFile(F);

         AsSignFile(F,Edit3.Text);
         ReSet(F);
         ReadLn(F,Trans2);
         CloseFile(F);

         If Length(Trans1) <> Length(Trans2) Then
            Error('Wrong Transfere Tables');
      Except
         Error('I/O Error');
      End;{TRY}
   End;

Procedure TForm1.Error(S:String);
   Begin
      Edit4.Text:=S;
   End;

procedure TForm1.Button5Click(Sender: TObject);
begin
   If FontDialog1.Execute Then
      Begin
         DBGrid1.Font:=FontDialog1.Font;
         DBGrid1.TitleFont:=FontDialog1.Font;
      End;
end;

end.
